// Sounds
freeslot("sfx_lvahit", "sfx_elchit", "sfx_shldon", "sfx_shldof", "sfx_shldbk",
"sfx_sthree", "sfx_stwo", "sfx_sone", "sfx_suddth", "sfx_sgo", "sfx_sgame",
"sfx_sbland", "sfx_sbhit", "sfx_sbget", "sfx_fsuse", "sfx_tslash", "sfx_lastht",
"sfx_meteor", "sfx_whoosh", "sfx_smcrit", "sfx_augasp", "sfx_sudchr",
"sfx_sdeath",

"sfx_fire1", "sfx_fire2", "sfx_fire3", "sfx_fire4",
"sfx_elec1", "sfx_elec2", "sfx_elec3",
"sfx_punch1", "sfx_punch2", "sfx_punch3",
"sfx_magic1", "sfx_magic2", "sfx_magic3", "sfx_magic4",
"sfx_kick1", "sfx_kick2", "sfx_kick3",
"sfx_sword1", "sfx_sword2", "sfx_sword3")

// Sprites
freeslot("SPR_HITS", "SPR_SLEF")

// Dummy Object
freeslot("MT_SMASH_DUMMY", "S_DUMMY")
mobjinfo[MT_SMASH_DUMMY] = {
	spawnstate = S_DUMMY,
	radius = 1*FRACUNIT,
	height = 1*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIP
}
states[S_DUMMY] = {SPR_NULL, A, -1, nil, 0, 0, S_DUMMY}

// Slash Effect
freeslot("S_SLASH_EFFECT1", "S_SLASH_EFFECT2", "S_SLASH_FADE1", "S_SLASH_FADE2", "S_SLASH_FADE3", "S_SLASH_FADE4")
states[S_SLASH_EFFECT1] = {SPR_SLEF, FF_TRANS10|A, 3, A_Thrust, 6, 0, S_SLASH_EFFECT2}
states[S_SLASH_EFFECT2] = {SPR_SLEF, FF_TRANS10|B, 5, nil, 0, 0, S_SLASH_FADE1}
states[S_SLASH_FADE1] = {SPR_SLEF, FF_TRANS20|B, 2, nil, 0, 0, S_SLASH_FADE2}
states[S_SLASH_FADE2] = {SPR_SLEF, FF_TRANS40|B, 2, nil, 0, 0, S_SLASH_FADE3}
states[S_SLASH_FADE3] = {SPR_SLEF, FF_TRANS60|B, 2, nil, 0, 0, S_SLASH_FADE4}
states[S_SLASH_FADE4] = {SPR_SLEF, FF_TRANS80|B, 2, nil, 0, 0, S_NULL}

// guh?
freeslot("MT_BADNIK_SMASH", "S_BADNIK_SMASH")
mobjinfo[MT_BADNIK_SMASH] = {
	spawnstate = S_BADNIK_SMASH,
	radius = 25*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_SCENERY
}

states[S_BADNIK_SMASH] = {SPR_POSS, A, -1, nil, 1, 1, S_BADNIK_SMASH}

// Ring Object
freeslot("MT_SMASH_RING")
mobjinfo[MT_SMASH_RING] = {
	spawnstate = S_RING,
	deathstate = S_COINSPARKLE1,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_BOUNCE|MF_GRENADEBOUNCE|MF_SPECIAL|MF_RUNSPAWNFUNC
}

// tails + fang stuff idk where to define
freeslot("S_BOMB_EXPLD")
states[S_BOMB_EXPLD] = {SPR_BARX, FF_ANIMATE|A, 16, nil, 4, 4, S_NULL}

// Hitboxes
freeslot("MT_HITBOXSMASH", "MT_HITBOXSMASH_ENEMY", "S_HITBOX_SMASH")
mobjinfo[MT_HITBOXSMASH] = {
	spawnstate = S_HITBOX_SMASH,
	deathstate = S_HITBOX_SMASH,
	radius = 1*FRACUNIT,
	height = 1*FRACUNIT,
	flags = MF_NOGRAVITY|MF_SPECIAL|MF_NOCLIPHEIGHT
}
mobjinfo[MT_HITBOXSMASH_ENEMY] = {
	spawnstate = S_HITBOX_SMASH,
	deathstate = S_HITBOX_SMASH,
	radius = 1*FRACUNIT,
	height = 1*FRACUNIT,
	flags = MF_NOGRAVITY|MF_SPECIAL|MF_NOCLIPHEIGHT
}
states[S_HITBOX_SMASH] = {SPR_NULL, A, -1, nil, 0, 0, S_HITBOX_SMASH}

// Extra States
freeslot("S_PLAY_SHIELD", "S_PLAY_CROUCH", "S_PLAY_PARRIED", "SPR2_CRCH", "SPR_SSLD", "SPR_WITS", "SPR2_PARY")
states[S_PLAY_SHIELD] = {SPR_PLAY, SPR2_EDGE, 3, nil, 0, 0, S_PLAY_STND}
states[S_PLAY_CROUCH] = {SPR_PLAY, SPR2_CRCH, 3, nil, 0, 0, S_PLAY_STND}
states[S_PLAY_PARRIED] = {SPR_PLAY, SPR2_PARY, 5, nil, 0, 0, S_PLAY_PARRIED}

// Camera
// Thank you flame for allowing me to use this
// -Spectra
freeslot("MT_PLAYCAM", "MT_CAMMIN", "MT_CAMMAX", "S_CAMSHIT")

mobjinfo[MT_PLAYCAM] = {
	spawnstate = S_CAMSHIT,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}

mobjinfo[MT_CAMMIN] = {
	doomednum = 3095,
	spawnstate = S_CAMSHIT,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}

mobjinfo[MT_CAMMAX] = {
	doomednum = 3096,
	spawnstate = S_CAMSHIT,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}

states[S_CAMSHIT] = {SPR_NULL, A, -1, nil, 0, 0, S_CAMSHIT}

// Smash Ball
freeslot("MT_SMASHBALL", "MT_SMASHBALL_GROUNDED", "MT_SMASHBALL_FAKE",
"S_SMASHBALL", "S_SMASHBALL_FAKE", "SPR_SBAL")
mobjinfo[MT_SMASHBALL] = {
	spawnstate = S_SMASHBALL,
	painstate = S_SMASHBALL,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_SMASHBALL_GROUNDED] = {
	spawnstate = S_SMASHBALL,
	painstate = S_SMASHBALL,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_BOUNCE
}

mobjinfo[MT_SMASHBALL_FAKE] = {
	spawnstate = S_SMASHBALL_FAKE,
	painstate = S_SMASHBALL_FAKE,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

states[S_SMASHBALL] = {SPR_SBAL, FF_FULLBRIGHT|A, -1, nil, 0, 0, S_SMASHBALL}
states[S_SMASHBALL_FAKE] = {SPR_SBAL, FF_FULLBRIGHT|B, -1, nil, 0, 0, S_SMASHBALL_FAKE}

// Item
freeslot("MT_ITEMPANEL", "S_IPANEL", "SPR_IPNL")
mobjinfo[MT_ITEMPANEL] = {
	spawnstate = S_IPANEL,
	deathstate = S_COINSPARKLE1,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_BOUNCE|MF_SPECIAL
}

states[S_IPANEL] = {SPR_IPNL, FF_FULLBRIGHT|FF_PAPERSPRITE|A, -1, nil, 0, 0, S_IPANEL}

addHook("MobjThinker", function(mo)
	if not P_IsObjectOnGround(mo) then P_SpawnGhostMobj(mo) end

	if mo.itemType and mo.state == S_IPANEL
		mo.frame = FF_FULLBRIGHT|FF_PAPERSPRITE|SRB2Smash.items[mo.itemType].frame
		mo.angle = $+ANG10
	end
end, MT_ITEMPANEL)

addHook("TouchSpecial", function(panel, mo)
	if not mo or not mo.valid then return true end
	if not panel or not panel.valid then return true end

	if SRB2Smash.items[panel.itemType]
		if SRB2Smash.items[panel.itemType].canpickup
			if not SRB2Smash.items[panel.itemType].canpickup(mo, panel)
				return true
			end
		end
	else
		return false
	end

	if panel.itemType
		mo.lastHit = 0
		mo.curItem = panel.itemType
		
		if SRB2Smash.items[mo.curItem].collectfunc then SRB2Smash.items[mo.curItem].collectfunc(mo) end
		if SRB2Smash.items[mo.curItem].useOnCollect then mo.curItem = nil end
		S_StartSound(mo, sfx_ncitem)
	end
end, MT_ITEMPANEL)

// Other
freeslot("MT_CENTERPOINT", "MT_UPBLAST", "MT_SIDEBLAST", "MT_DOWNBLAST")
mobjinfo[MT_CENTERPOINT] = {
	doomednum = 3097,
	spawnstate = S_INVISIBLE,
	radius = FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY
}

mobjinfo[MT_UPBLAST] = {
	doomednum = 3098,
	spawnstate = S_INVISIBLE,
	radius = FRACUNIT,
	height = 140*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_SIDEBLAST] = {
	doomednum = 3099,
	spawnstate = S_INVISIBLE,
	radius = 140*FRACUNIT,
	height = FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_DOWNBLAST] = {
	doomednum = 3100,
	spawnstate = S_INVISIBLE,
	radius = FRACUNIT,
	height = 140*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

for i = MT_UPBLAST, MT_DOWNBLAST
	addHook("MobjThinker", function(mo)
		if not server then return end
		if not server.blastZones then return end

		if not mo.addedToBlastZone
			table.insert(server.blastZones, mo)
			mo.addedToBlastZone = true
		end
	end, i)
end

// Some shit
addHook("MobjThinker", function(mo)
	if not SRB2Smash.isSmash() then return end

	if mo.target and mo.target.valid
		if P_AproxDistance(P_AproxDistance(mo.x - mo.target.x, mo.y - mo.target.y), mo.z - mo.target.z) <= 64*FRACUNIT
			P_RemoveMobj(mo)
			return
		end

		local dist = P_AproxDistance(P_AproxDistance(mo.target.x - mo.x, mo.target.y - mo.y), mo.target.z - mo.z)
		mo.momx = FixedMul(FixedDiv(mo.target.x - mo.x, dist), 20<<FRACBITS)
		mo.momy = FixedMul(FixedDiv(mo.target.y - mo.y, dist), 20<<FRACBITS)
		mo.momz = FixedMul(FixedDiv(mo.target.z - mo.z, dist), 20<<FRACBITS)
	end
end, MT_MSGATHER)

// Title screen mobjs
freeslot("MT_TITLE_SONIC", "MT_TITLE_TAILS", "MT_TITLE_KNUCKLES", "MT_TITLE_AMY",
"MT_TITLE_METAL", "MT_TITLE_FANG", "S_TITLEMOBJ", "S_TITLEMOBJ_EGGMAN")

local k = 0
local skinMobjs = {
	[MT_TITLE_SONIC] = "sonic",
	[MT_TITLE_TAILS] = "tails",
	[MT_TITLE_KNUCKLES] = "knuckles",
	[MT_TITLE_AMY] = "amy",
	[MT_TITLE_METAL] = "metalsonic",
	[MT_TITLE_FANG] = "fang",
}

for i = MT_TITLE_SONIC, MT_TITLE_FANG
	mobjinfo[i] = {
		spawnstate = S_TITLEMOBJ,
		doomednum = 3101+(k or 0),
		radius = 1*FRACUNIT,
		height = 1*FRACUNIT,
		flags = MF_SCENERY
	}

	addHook("MobjSpawn", function(mo)
		mo.skin = skinMobjs[mo.type] or "sonic"
		mo.color = skins[mo.skin].prefcolor
	end, i)

	k = $+1
end

states[S_TITLEMOBJ] = {SPR_PLAY, SPR2_IDLE, -1, nil, 0, 0, S_TITLEMOBJ}