local s = SRB2Smash

/*
	MOBJ SHIT
	Ring stuff ig
*/

s.loseRings = function(mo, inf, dmg)
	if not s.isSmash() then return end
	if not mo.smashRings then return end

	local ringCount
	if dmg then
		ringCount = dmg/2
	elseif mo.smashRings > 5 then
		ringCount = mo.smashRings/3
	else 
		ringCount = mo.smashRings
	end

	if (ringCount > mo.smashRings) then ringCount = mo.smashRings end

	for i = 1, ringCount
		if inf and inf.valid and inf.shield and inf.shield.ringSteal then
			local mobj = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMASH_RING)
			mobj.collectCooldown = 10
			mobj.ringSteal = inf

			mobj.momx = P_RandomRange(-10, 10)*FRACUNIT
			mobj.momy = P_RandomRange(-10, 10)*FRACUNIT
			mobj.momz = P_RandomRange(-10, 10)*FRACUNIT
		else
			local mobj = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMASH_RING)
			mobj.collectCooldown = 35 
//			mobj.scalespeed = FRACUNIT/69
//			mobj.destscale = 1
//			mobj.fuse = 35

			mobj.momx = P_RandomRange(-10, 10)*FRACUNIT
//			mobj.momy = P_RandomRange(-10, 10)*FRACUNIT
//			mobj.momz = P_RandomRange(-10, 10)*FRACUNIT
		end
	end

	mo.smashRings = max(0, $-ringCount)
end

s.getRing = function(ring, mo)
	if not s.isSmash() then return end
	if not mo or not mo.valid then return false end
	if not ring or not ring.valid then return false end
	if mo.hitcool or mo.hitstun then return true end
	if mo.smashRings and mo.smashRings > 30 then return true end
	if ring.collectCooldown then return true end

	// Get the ring
	if not mo.smashRings
		mo.smashRings = 1
	else
		mo.smashRings = min(30, $+1)
	end
	
	// Total Rings Collected
	if mo.player and mo.player.finalScoreStuff
		if mo.player.finalScoreStuff.ringtotal
			mo.player.finalScoreStuff.ringtotal = $+1
		else
			mo.player.finalScoreStuff.ringtotal = 1
		end
	end
end

s.ringThinker = function(mo)
	if not s.isSmash() then return end

	if mo.collectCooldown
		mo.collectCooldown = $-1
		if mo.collectCooldown <= 0 then mo.collectCooldown = nil end
		return
	end
	
	if mo.ringSteal
		local mo2 = mo.ringSteal
		local dist = P_AproxDistance(P_AproxDistance(mo2.x - mo.x, mo2.y - mo.y), mo2.z - mo.z)
		mo.momx = FixedMul(FixedDiv(mo2.x - mo.x, dist), 20<<FRACBITS)
		mo.momy = FixedMul(FixedDiv(mo2.y - mo.y, dist), 20<<FRACBITS)
		mo.momz = FixedMul(FixedDiv(mo2.z - mo.z, dist), 20<<FRACBITS)
		P_SpawnGhostMobj(mo)
	end
end

/*
	RING BUFFS
	- Slight damage buff
	- Damage Resistance at 25 rings
	- Jump height buff and speed buff
*/

s.doRingBuff = function(mo)
	if not s.isSmash() then return false end
	if not mo or not mo.valid then return false end
	if not mo.smashRings then return false end
	if mo.smashRings <= 0 then return false end
	if s.curAttack(mo).noringbuff then return false end
	return true
end