local s = SRB2Smash

for i = 1, 18
	freeslot("S_PLAY_FLICKY"..i)
end

states[S_PLAY_FLICKY1] = {SPR_FL01, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY1}
states[S_PLAY_FLICKY2] = {SPR_FL02, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY2}
states[S_PLAY_FLICKY3] = {SPR_FL03, FF_ANIMATE|A, -1, nil, 5, 4, S_PLAY_FLICKY3}
states[S_PLAY_FLICKY4] = {SPR_FL04, FF_ANIMATE|A, -1, nil, 5, 4, S_PLAY_FLICKY4}
states[S_PLAY_FLICKY5] = {SPR_FL05, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY5}
states[S_PLAY_FLICKY6] = {SPR_FL06, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY6}
states[S_PLAY_FLICKY7] = {SPR_FL07, FF_ANIMATE|A, -1, nil, 7, 4, S_PLAY_FLICKY7}
states[S_PLAY_FLICKY8] = {SPR_FL08, FF_ANIMATE|A, -1, nil, 3, 4, S_PLAY_FLICKY8}
states[S_PLAY_FLICKY9] = {SPR_FL09, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY9}
states[S_PLAY_FLICKY10] = {SPR_FL10, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY10}
states[S_PLAY_FLICKY11] = {SPR_FL11, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY11}
states[S_PLAY_FLICKY12] = {SPR_FL12, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY12}
states[S_PLAY_FLICKY13] = {SPR_FL13, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY13}
states[S_PLAY_FLICKY14] = {SPR_FL14, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY14}
states[S_PLAY_FLICKY15] = {SPR_FL15, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY15}
states[S_PLAY_FLICKY16] = {SPR_FL16, FF_ANIMATE|A, -1, nil, 4, 4, S_PLAY_FLICKY16}
states[S_PLAY_FLICKY17] = {SPR_FS01, B, -1, nil, 3, 4, S_PLAY_FLICKY17}
states[S_PLAY_FLICKY18] = {SPR_FS02, A, -1, nil, 4, 4, S_PLAY_FLICKY18}

s.spectatorThinker = function(p)
	if p.supposedToBeInThisGame
		p.smashSpectate = nil
		p.mo.tempSpectate = nil
		p.supposedToBeInThisGame = nil
		p.pflags = $ & ~PF_GODMODE & ~PF_INVIS

		p.mo.state = S_PLAY_STND
		p.playerstate = PST_REBORN
		return
	end

	if p.mo and p.mo.valid and (p.smashSpectate or p.mo.tempSpectate)
		p.pflags = $|PF_GODMODE|PF_INVIS
		s.inputRegister(p)

		p.lives = 3
		if not p.mo.flicky then p.mo.flicky = P_RandomRange(1, 18) end

//		if p.mo.state ~= _G["S_PLAY_FLICKY"..p.mo.flicky]
			p.mo.state = _G["S_PLAY_FLICKY"..p.mo.flicky]
//		end

		p.mo.flags = $|MF_NOCLIPTHING

		if not P_IsObjectOnGround(p.mo) and p.mo.button.jump == 1
			P_SetObjectMomZ(p.mo, 10*FRACUNIT)
			S_StartSound(p.mo, sfx_ngjump)
		end
		
		if p.mo.button.spin == 1 and not p.tutorialShit then s.openTutorial(p) end
	end
end

s.spectatorToggle = function(p)
	if p.mo and p.mo.valid and p.mo.button
		if p.mo.button.tossflag == 1 and not p.tutorialShit
			COM_BufInsertText(p, "smash_spectate")
		end
	end
end