// game shit
-- Use Stocks?
rawset(_G, "cv_stocks", CV_RegisterVar({
	name = "smash_stocks",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_SAVE,
	PossibleValue = CV_OnOff,
}))

-- Starting Stocks
rawset(_G, "cv_stockcount", CV_RegisterVar({
	name = "smash_startstocks",
	defaultvalue = 3,
	flags = CV_NETVAR|CV_SAVE,
	PossibleValue = {MIN = 1, MAX = 10},
}))

-- Limiting Players
rawset(_G, "cv_plimit", CV_RegisterVar({
	name = "smash_limit",
	defaultvalue = 0,
	flags = CV_NETVAR|CV_SAVE,
	PossibleValue = CV_OnOff,
}))

-- Amount of players in a match
rawset(_G, "cv_matchlimit", CV_RegisterVar({
	name = "smash_maxplayers",
	defaultvalue = 2,
	flags = CV_NETVAR|CV_SAVE,
	PossibleValue = {MIN = 1, MAX = 8},
}))

-- Percent players start with
rawset(_G, "cv_startpercent", CV_RegisterVar({
	name = "smash_startpercent",
	defaultvalue = 0,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 0, MAX = 999},
}))

-- HP players start with
rawset(_G, "cv_starthp", CV_RegisterVar({
	name = "smash_starthp",
	defaultvalue = 200,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 10, MAX = 999},
}))

-- Rings players start with
rawset(_G, "cv_startrings", CV_RegisterVar({
	name = "smash_startrings",
	defaultvalue = 5,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 0, MAX = 30},
}))

-- Amount of teams
rawset(_G, "cv_teamcount", CV_RegisterVar({
	name = "smash_teams",
	defaultvalue = 2,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 2, MAX = 4},
}))

-- Game Time Limit
rawset(_G, "cv_smashtime", CV_RegisterVar({
	name = "smash_timelimit",
	defaultvalue = 420,
	flags = CV_NETVAR|CV_SAVE,
	PossibleValue = {MIN = 30, MAX = 600},
}))

-- Sudden Death?
rawset(_G, "cv_suddendeath", CV_RegisterVar({
	name = "smash_suddendeath",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_SAVE,
	PossibleValue = CV_OnOff
}))

-- Camera?
rawset(_G, "cv_smashcam", CV_RegisterVar({
	name = "smash_camera",
	defaultvalue = 1,
	flags = CV_SAVE,
	PossibleValue = CV_OnOff
}))

-- Items?
rawset(_G, "cv_items", CV_RegisterVar({
	name = "smash_items",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_SAVE,
	PossibleValue = CV_OnOff,
}))

-- Item Spawn Rate?
rawset(_G, "cv_itemspawnrate", CV_RegisterVar({
	name = "smash_itemrate",
	defaultvalue = 2,
	flags = CV_NETVAR|CV_SAVE,
	PossibleValue = {MIN = 1, MAX = 3},
}))

-- Final Smashes?
rawset(_G, "cv_finalsmashes", CV_RegisterVar({
	name = "smash_finalsmashes",
	defaultvalue = 1,
	flags = CV_SAVE|CV_NETVAR,
	PossibleValue = CV_OnOff
}))

-- FS Meter?
rawset(_G, "cv_fsmeter", CV_RegisterVar({
	name = "smash_fsmeter",
	defaultvalue = 0,
	flags = CV_SAVE|CV_NETVAR,
	PossibleValue = CV_OnOff
}))

// other shit
-- The time it takes to vote
rawset(_G, "cv_votetime", CV_RegisterVar({
	name = "smash_votetime",
	defaultvalue = 20,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 10, MAX = 60},
}))

-- Auto Spectate on join?
rawset(_G, "cv_autospec", CV_RegisterVar({
	name = "smash_joinspectate",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_SAVE,
	PossibleValue = CV_OnOff,
}))

COM_AddCommand("smash_spectate", function(p)
	if p.mo and p.mo.valid and p.mo.tempSpectate
		CONS_Printf(p, "You're forced into spectator mode right now.")
		return
	end
	
	if cv_plimit.value
		CONS_Printf(p, "You can't spectate right now!")
		return
	end

	if not p.smashSpectate
		if server.voting
			CONS_Printf(p, "You cannot leave mid-vote.")
			return
		end

		if (leveltime > 15*TICRATE)
			CONS_Printf(p, "The game has gone on too long to leave.")
			return
		end

		chatprint(p.name.." is spectating.")
		p.smashSpectate = true
	else
		if (leveltime > 15*TICRATE) then return CONS_Printf(p, "The game has gone on too long to join it now.") end
		if server.suddenDeath then return CONS_Printf(p, "You cannot join during sudden death.") end
		if server.voting then return CONS_Printf(p, "You cannot join mid-vote.") end
		if SRB2Smash.isTeam() then SRB2Smash.assignTeamOnLateJoin(p) end

		chatprint(p.name.." has entered the game.")
		p.mo.state = S_PLAY_STND
		p.playerstate = PST_REBORN

		p.smashSpectate = false
	end
end)

COM_AddCommand("smash_tutorial", function(p)
	SRB2Smash.openTutorial(p)
end)

COM_AddCommand("smash_getfs", function(p, type)
	if p.mo and p.mo.valid
		SRB2Smash.getFinalSmash(p.mo)
	else
		CONS_Printf(p, "bro wheres your mobj")
	end
end, COM_ADMIN)

COM_AddCommand("smash_specialbtn", function(p, btnType)
	if btnType 
		if btnType:lower() == "custom1"
		or btnType:lower() == "c1"
			p.specialBtn = "custom1"
		end
	else
		p.specialBtn = "fire"
	end
end, COM_ADMIN)

// Since this is the last file that'll get loaded
print("HI!!!")
print("We know, this isn't the real Sonic Robo Smash.")
print("This is one of the earlier versions of Sonic Robo Smash, known as SRB2Smash at the time, that popped up in early 2020.")
print("We've fixed up this version to atleast be playable. You probably have some variation of this version already, if you played early on.")
print("Take this as a legacy version, we hope you enjoy it!")
print("                        - Smash Studio")