local convertChar = function(char)
    return string.byte(char)-string.byte("A")
end

local s = SRB2Smash

s.getMapFromInt = function(int)	
	if int < 0 or int > 1035 then return nil end
	if int < 10 then return "MAP0"..int end
	if int < 100 then return "MAP"..int end

	local x = int - 100
	local p = x/36
	local q = x - (36 * p)
	local a = string.char(65 + p)
	local b
	if q < 10 then b = q else b = string.char(55 + q) end
	return "MAP"..(a + b)
end

s.getIntFromMap = function(map)
	map = map:upper()
	if map:sub(1, 3) == "MAP" then map = map:sub(4,5) end
	
    local num = tonumber(ext)
    if num then return num end
	
	if map:len() > 2 then return nil end
	
    local x = map:sub(1,1)
	if tonumber(x) then return nil end

    local y = map:sub(2,2)
    local p = convertChar(x)
    local q = tonumber(y)
    if q == nil then q = 10 + convertChar(y) end
    return ((36*p + q) + 100)
end