local s = SRB2Smash

s.badniks["Crawla"] = {
	["speed"] = 3,
	["weight"] = 7,

	["attack"] = {
		anim = function(mo, timer)
			if timer <= 10
				P_InstaThrust(mo, mo.angle, 8*FRACUNIT)
				mo.rollangle = $+ANG20
			end

			if timer > 2 and timer < 6
				local hitbox = s.drawHitBoxEnm(mo, 0, 0, -mo.height/2, mo.radius*3,
				p.mo.height*2, 1, 2, mo.momx, mo.momz, false, sfx_punch1, "punch")
				hitbox.angle = mo.angle
				hitbox.hitcool = 2
				hitbox.hitlag = 2
				hitbox.fuse = 2
			elseif timer >= 6 and timer <= 10
				local hitbox = s.drawHitBoxEnm(mo, 0, 0, -mo.height/2, mo.radius*3,
				p.mo.height*2, 3, 3, 6*FRACUNIT, 5*FRACUNIT, true, sfx_punch2, "sweet")
				hitbox.hitcool = 10
				hitbox.hitlag = 10
				hitbox.fuse = 2
			end
			
			if timer >= 10
				mo.rollangle = 0
				return true
			end
		end,
	},

	["aerial"] = {
		anim = function(mo, timer)
			if timer <= 10
				mo.rollangle = $+ANG20
			end

			if timer > 2 and timer < 6
				local hitbox = s.drawHitBoxEnm(mo, 0, 0, -mo.height/2, mo.radius*3,
				p.mo.height*2, 1, 2, mo.momx, mo.momz, false, sfx_punch1, "punch")
				hitbox.angle = mo.angle
				hitbox.hitcool = 2
				hitbox.hitlag = 2
				hitbox.fuse = 2
			elseif timer >= 6 and timer <= 10
				local hitbox = s.drawHitBoxEnm(mo, 0, 0, -mo.height/2, mo.radius*3,
				p.mo.height*2, 3, 3, 6*FRACUNIT, 5*FRACUNIT, true, sfx_punch2, "sweet")
				hitbox.hitcool = 10
				hitbox.hitlag = 10
				hitbox.fuse = 2
			end
			
			if timer >= 10
				mo.rollangle = 0
				return true
			end
		end,
	},
	
	["special"] = {
		ranged = true,
		anim = function(mo, timer)
			if timer == 3
				s.fireMissile(mo, MT_JETTBULLET, 2)
			end
			
			if timer >= 20 then return true end
		end,
	},
	
	["recovery"] = {
		anim = function(mo, timer)
			if timer < 10
				mo.momz = $+FRACUNIT
			end
			
			if timer >= 15 then return true end
		end,
	},

	["blast"] = {
		nomove = true,
		anim = function(mo, timer)
			if timer >= 20 then return true end
		end,
	}
}

s.badniks["Red Crawla"] = s.badniks["Crawla"]