local s = SRB2Smash

s.runHazard = function(map)
	if s.hazards[map]
		server.doHazard = true
	end
end

s.hazardThinker = function()
	if s.hazards[gamemap]
		if not server.doHazard
			if not server.hazardTimer
				server.hazardTimer = s.hazards[gamemap].time or 30*TICRATE
			end
			
			server.hazardTimer = $-1
			if server.hazardTimer <= 0
				s.runHazard(gamemap)
			end

			return
		end
		
		if s.hazards[gamemap]
			if not server.hazardTimer
				server.hazardTimer = 0
			end
			
			server.hazardTimer = $+1

			if (s.hazards[gamemap].func and s.hazards[gamemap].func(server.hazardTimer))
			or not s.hazards[gamemap].func
				server.doHazard = nil
				server.hazardTimer = nil
			end
		end
	end
end
