local s = SRB2Smash
freeslot("MT_SMASH_SPIKEBALL", "S_SMASH_SPIKEBALL")

mobjinfo[MT_SMASH_SPIKEBALL] = {
    spawnstate = S_SMASH_SPIKEBALL,
    radius = 64*FRACUNIT,
    height = 64*FRACUNIT,
	flags = MF_BOUNCE|MF_PAIN|MF_GRENADEBOUNCE
}

states[S_SMASH_SPIKEBALL] = {SPR_BMCE, A, 1050, nil, 0, 0, S_NULL}

s.mobjDefs[MT_SMASH_SPIKEBALL] = {
	hitsound = sfx_sword3,
	hitstun = 10,
	hitlag = 4,
	hitcool = 10,
	x = 8*FRACUNIT,
	y = 3*FRACUNIT,
	mod = true,
	dmg = 10,
}

addHook("MobjThinker", function(mo)
	if mo.repelMovement
		if not mo.resumeMove then
			mo.resumeMove = {
				x = -mo.momx,
				y = -mo.momy,
				z = -mo.momz,
				state = mo.state
			}
		end

		mo.state = mo.resumeMove.state
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0

		mo.repelMovement = $-1
		if mo.repelMovement <= 0
			if mo.shouldNotRepel
				mo.momx = -mo.resumeMove.x
				mo.momy = -mo.resumeMove.y
				mo.momz = -mo.resumeMove.z
			else
				mo.momx = mo.resumeMove.x or 5*FRACUNIT
				mo.momy = mo.resumeMove.y or 0
				mo.momz = mo.resumeMove.z or 5*FRACUNIT
			end

			mo.repelled = true
			mo.resumeMove = nil
			mo.repelMovement = nil
			mo.shouldNotRepel = nil
		end
		
		return
	end
	
	if mo.hitcool
		mo.hitcool = $-1
		if mo.hitcool <= 0 then mo.hitcool = nil end
	end

	if not P_IsObjectOnGround(mo) or ((mo.momx ~= 0) and (mo.momy ~= 0))
		mo.rollangle = $+ANGLE_22h
	end
end, MT_SMASH_SPIKEBALL)