local s = SRB2Smash

s.botInit = function(mo)
	mo.bot = true
	
	local skinChars = {"sonic", "tails", "knuckles", "amy", "fang", "metalsonic"}
	mo.skin = skinChars[P_RandomRange(1, #skinChars)]
end

s.botThinker = function(mo)
	mo.target = P_LookForPlayers(mo)

	local targ = mo.target
	if targ and targ.valid
		if not mo.attacktype
			mo.angle = R_PointToAngle2(mo.x, mo.y, targ.x, targ.y)
			P_Thrust(mo, mo.angle, 2*FRACUNIT)
			
			if P_IsObjectOnGround(mo)
				if (mo.momx > 23*FRACUNIT)
					mo.state = S_PLAY_RUN
					mo.momx = 23*FRACUNIT
				else
					mo.state = S_PLAY_WALK
				end
			else
				mo.state = S_PLAY_JUMP
			end
			
			if mo.momx > 36*FRACUNIT then mo.momx = 36*FRACUNIT end
			if mo.momy > 36*FRACUNIT then mo.momy = 36*FRACUNIT end
		end
		
		if targ.z > mo.z + 100*FRACUNIT and P_IsObjectOnGround(mo)
			P_SetObjectMomZ(mo, 15*FRACUNIT, true)
			S_StartSound(mo, sfx_ngjump)
		end

		if targ.z < mo.z + 100*FRACUNIT and targ.z > mo.z + 50*FRACUNIT
			s.pressButton(mo, "up")
			s.pressButton(mo, "spin")
		end
	else
		mo.state = S_PLAY_STND
	end
end
