local s = SRB2Smash

s.mobjPosOnScreen = function(v, p, c, mo)
	local camx, camy, camz, camangle, camaiming
	if p.awayviewtics
		camx = p.awayviewmobj.x
		camy = p.awayviewmobj.y
		camz = p.awayviewmobj.z
		camangle = p.awayviewmobj.angle
		camaiming = p.awayviewaiming
	elseif c.chase
		camx = c.x
		camy = c.y
		camz = c.z
		camangle = c.angle
		camaiming = c.aiming
	else
		camx = p.mo.x
		camy = p.mo.y
		camz = p.viewz-20*FRACUNIT
		camangle = p.mo.angle
		camaiming = p.aiming
	end
	
	local mox, moy, moz
	if mo and mo.valid
		mox, moy, moz = mo.x, mo.y, mo.z
	else
		return 0, 0, 0
	end

	local x = camangle-R_PointToAngle2(camx, camy, mox, moy)
	local distFactor = cos(x) or 1

	if x > ANGLE_90 or x < ANGLE_270
		return -9, -9, 0
	else
		x = FixedMul(tan(x, true), 160<<FRACBITS)+160<<FRACBITS
	end

	local y = camz-moz
	y = FixedDiv(y, FixedMul(distFactor, R_PointToDist2(camx, camy, mox, moy)))
	y = (y*160)+(100<<FRACBITS)
	y = y+tan(camaiming, true)*160

	local scale = FixedDiv(160*FRACUNIT, FixedMul(distFactor, R_PointToDist2(camx, camy, mox, moy)))

	-- this is like the hardest shit ive done man oh my g
	return x, y, scale
end