local s = SRB2Smash

// SRB2Smash Titlecard Element
local XMove_GameFrom = 0
local XMoveRate = 20

-- i'm sure they'll let me put this here right
addHook("MapLoad", function()
	if s.isSmash()
		XMove_GameFrom = 0
		XMoveRate = 20
	end
end)

s.gameFromPatches = {
	SRB2 = "GF_SRB2",
	SmashBros =  "GF_SMASH",
	TF2 =  "GF_TF2",
	StarStages = "GF_SSTAG",
	Sonic4 = "GF_SONIC4",
	SRB2Smash =  "GF_SRB2SM",
}

-- Function
s.smashIntro = function(v, p, ticker, endticker)
	if s.isSmash()
		if ticker == endticker
			return
		end

		XMove_GameFrom = $ + XMoveRate

		if XMoveRate > 0 and ticker < endticker*13/20
			XMoveRate = $ - 1
		elseif ticker > endticker*13/20
			XMoveRate = $ + 5
		end

		local gamefrom = mapheaderinfo[gamemap].gamefrom
		if gamefrom and s.gameFromPatches[gamefrom] then
			v.drawScaled(370*FRACUNIT - XMove_GameFrom*FRACUNIT, 150*FRACUNIT, FRACUNIT/2, v.cachePatch(s.gameFromPatches[gamefrom]), V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_PERPLAYER)
		end
	end
end